// dbx-min-coverage: 0% because it's extracting the hard to test portion of the code

/*
 * Copyright (c) 2018, Dropbox, Inc. All rights reserved.
 */

package com.dropbox.android.payments

import android.app.Activity
import android.content.Intent
import android.content.IntentSender

/**
 * Wrapper interface for starting an [IntentSender].
 */
interface IntentSenderStarter {

    /**
     * Starts the [IntentSender].
     * @see Activity.startIntentSenderForResult
     */
    @Throws(IntentSender.SendIntentException::class)
    fun startIntentSenderForResult(
        intent: IntentSender,
        requestCode: Int,
        fillInIntent: Intent?,
        flagsMask: Int,
        flagsValues: Int,
        extraFlags: Int
    )
}

/**
 * Implementation of [IntentSenderStarter] that delegates the call to an [Activity].
 */
class ActivityIntentSenderStarter(val activity: Activity) :
    IntentSenderStarter {

    override fun startIntentSenderForResult(
        intent: IntentSender,
        requestCode: Int,
        fillInIntent: Intent?,
        flagsMask: Int,
        flagsValues: Int,
        extraFlags: Int
    ) {
        activity.startIntentSenderForResult(
            intent,
            requestCode,
            fillInIntent,
            flagsMask,
            flagsValues,
            extraFlags
        )
    }
}
