// dbx-min-coverage: 0% because grandfathered
/*
 * Copyright (c) 2018, Dropbox, Inc. All rights reserved.
 */

package com.dropbox.android.util

import android.support.v4.app.Fragment
import android.support.v4.app.FragmentManager
import java.util.*

fun FragmentManager.findFragmentByTagRecursive(tag: String): Fragment? {
    val fms = LinkedList<FragmentManager>()
    fms.add(this)

    while (!fms.isEmpty()) {
        val fragmentManager = fms.poll()

        fragmentManager.findFragmentByTag(tag)?.let {
            return it
        }

        fms.addAll(fragmentManager.fragments.asSequence().map { it.childFragmentManager })
    }

    return null
}
