// dbx-min-coverage: 40% because grandfathered
/*
 * Copyright (c) 2017, Dropbox, Inc. All rights reserved.
 */

package com.dropbox.core.search.service

import com.google.gson.annotations.SerializedName

/**
 * Creates a request object for Search Requests with appropriate default values.
 */
data class SearchRequest(
    var query: String,
    @SerializedName("file_limit") var fileLimit: Int = 100,
    @SerializedName("show_paper_results") var showPaperResults: Boolean = true
) {
    /**
     * This is to support default values for Java bridging.  There may be a better way to do this,
     * but I'd don't currently know it.
     */
    constructor(query: String) : this(query, 100, true)
}
