// dbx-min-coverage: 5% because grandfathered
/*
 * Copyright (c) 2017, Dropbox, Inc. All rights reserved.
 */

package com.dropbox.core.search.service

import com.google.gson.annotations.SerializedName

data class SearchResult(
    @SerializedName("parent_shared_folder_id") val mParentSharedFolderId: String?,
    @SerializedName("match_type") val matchType: String?,
    val rev: String?,
    @SerializedName("thumb_exists") val thumbExists: Boolean?,
    @SerializedName("search_result_type") val searchResultType: String?,
    val path: String?,
    @SerializedName("is_dir") val isDir: Boolean?,
    @SerializedName("content_hash") val contentHash: String?,
    val icon: String?,
    @SerializedName("read_only") val readOnly: Boolean?,
    @SerializedName("filename_highlights") val filenameHighlights: List<FilenameHighlights>?,
    val modifier: ResultModifier?,
    @SerializedName("is_parent_shared_folder_read_only") val isParentSharedFolderReadOnly: Boolean?,
    val bytes: Int?,
    val modified: String?,
    @SerializedName("no_access") val noAccess: Boolean?,
    @SerializedName("is_team_member_folder") val isTeamMemberFolder: Boolean?,
    val score: Double?,
    @SerializedName("mime_type") val mimeType: String?,
    val size: String?,
    val root: String?,
    val revision: Int?
)

data class ResultModifier(
    @SerializedName("display_name") val displayName: String?,
    val uid: Long?,
    @SerializedName("same_team") val sameTeam: Boolean?,
    @SerializedName("email_verified")
    val emailVerified: Boolean?,
    @SerializedName("dbx_id") val dbxId: String?,
    val email: String?
)

data class FilenameHighlights(
    val pos: Int?,
    val len: Int?,
    val string: String?
)
